#include <bits/stdc++.h>

#define err(...) fprintf(stderr, __VA_ARGS__), fflush(stderr)
typedef long long ll;

using namespace std;

double dosmth(double b, double a1, double a2) {
    if (b <= a1) {
        return b / 2;
    }
    if (b <= a2) {
        return a1 / 2;
    }
    return a1 / 2 + (b - a2) / 2;
}

double undo(double c2, double a1, double a2) {
    if (c2 <= a1 / 2) {
        return 2 * c2;
    }
    if (c2 <= a2 / 2) {
        return c2 + a1 / 2;
    }
    return 2 * (c2 - a2 / 2 + a1 / 2);
}

double get_c1(double c2, double a1, double a2) {
    if (a1 == a2) {
        return c2;
    }
    double b = undo(c2, a1, a2);
    return dosmth(b, a1, a2);
}

vector<double> get(double s, vector<pair<double, int> > A) {
    int n = A.size();
    vector<double> R(n);
    R[A[0].second] = s;
    for (int i = 1; i < n; i++) {
        s = get_c1(s, A[i].first, A[i - 1].first);
        R[A[i].second] = s;
    }
    return R;
}

void solve() {
    int n;
    cin >> n;
    double S;
    vector<pair<double, int> > E(n);
    for (int i = 0; i < n; i++) {
        double t;
        cin >> t;
        E[i] = {t, i};
    }
    sort(E.begin(), E.end());
    reverse(E.begin(), E.end());
    cin >> S;

    double l = 0, r = E.front().first;
    for (int i = 0; i < 100; i++) {
        double s = (l + r) / 2;
        auto T = get(s, E);
        double sum = 0;
        for (auto t : T) {
            sum += t;
        }
        if (sum > S) {
            r = s;
        } else {
            l = s;
        }
    }
    auto T = get(l, E);
    for (double x : T) {
        printf("%0.12f\n", x);
    }
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
#ifdef SIR
    freopen("input.txt", "r", stdin); freopen("output.txt", "w", stdout);
#endif
    solve();
    return 0;
}