#include <bits/stdc++.h>

#define err(...) fprintf(stderr, __VA_ARGS__), fflush(stderr)
typedef long long ll;

using namespace std;

const int dd = (int)2e5 + 7;

int n;
int l[dd], r[dd];
vector<pair<int, int>> Q[dd];
ll ans[dd];

struct SegmentTree {

    int P[4 * dd];
    ll S[4 * dd];
    int Mx[4 * dd];

    void clear() {
        fill(S, S + 4 * dd, 0);
        fill(Mx, Mx + 4 * dd, 0);
        fill(P, P + 4 * dd, -1);
    }

    void push(int v, int tl, int tr) {
        if (P[v] != -1) {

            Mx[v] = P[v];
            S[v] = 1ll * (tr - tl + 1) * P[v];

            if (tl != tr) {
                P[v * 2] = P[v * 2 + 1] = P[v];
            }
            P[v] = -1;
        }
    }

    void build(int v, int tl, int tr, int *A) {
        P[v] = -1;
        if (tl == tr) {
            S[v] = Mx[v] = A[tl];
        } else {
            int tm = (tl + tr) / 2;
            build(v * 2, tl, tm, A);
            build(v * 2 + 1, tm + 1, tr, A);

            S[v] = S[v * 2] + S[v * 2 + 1];
            Mx[v] = max(Mx[v * 2], Mx[v * 2 + 1]);
        }
    }

    void upd(int v, int tl, int tr, int l, int r, int val) {
        if (l > r) return;
        push(v, tl, tr);
        if (tl == l && tr == r) {
            P[v] = val;
        } else {
            int tm = (tl + tr) / 2;

            if (r <= tm) upd(v * 2, tl, tm, l, r, val);
            else if (l > tm) upd(v * 2 + 1, tm + 1, tr, l, r, val);
            else upd(v * 2, tl, tm, l, tm, val), upd(v * 2 + 1, tm + 1, tr, tm + 1, r, val);

            push(v * 2, tl, tm);
            push(v * 2 + 1, tm + 1, tr);

            S[v] = S[v * 2] + S[v * 2 + 1];
            Mx[v] = max(Mx[v * 2], Mx[v * 2 + 1]);
        }
    }

    ll get(int v, int tl, int tr, int l, int r) {
        push(v, tl, tr);
        if (tl == l && tr == r) return S[v];

        int tm = (tl + tr) / 2;
        if (r <= tm) return get(v * 2, tl, tm, l, r);
        if (l > tm) return get(v * 2 + 1, tm + 1, tr, l, r);
        return get(v * 2, tl, tm, l, tm) + get(v * 2 + 1, tm + 1, tr, tm + 1, r);
    }

    int getR(int v, int tl, int tr, int pos, int val) {
        push(v, tl, tr);
        if (Mx[v] < val) return n;
        if (tr <= pos) return n;

        if (tl == tr) return tl;
        int tm = (tl + tr) / 2;

        int t = getR(v * 2, tl, tm, pos, val);
        if (t != n) return t;

        return getR(v * 2 + 1, tm + 1, tr, pos, val);
    }

    int getL(int v, int tl, int tr, int pos, int val) {
        push(v, tl, tr);
        if (Mx[v] < val) return -1;
        if (pos <= tl) return -1;

        if (tl == tr) return tl;
        int tm = (tl + tr) / 2;

        int t = getL(v * 2 + 1, tm + 1, tr, pos, val);
        if (t != -1) return t;

        return getL(v * 2, tl, tm, pos, val);
    }
} K, L, R;

void solve() {
    cin >> n;
    for (int i = 0; i < n - 1; ++i) {
        int x;
        cin >> x;
        r[i] = l[i + 1] = x;
    }
    l[0] = (int)1e9 + 7, r[n - 1] = (int)1e9 + 7;
    int q;
    cin >> q;
    for (int i = 0; i < q; ++i) {
        int a, b;
        cin >> a >> b;
        --a, --b;
        Q[b].emplace_back(a, i);
    }
    L.build(1, 0, n - 1, l), R.build(1, 0, n - 1, r);
    for (int i = 0; i < n; ++i) {
        K.upd(1, 0, n - 1, K.getL(1, 0, n - 1, i, l[i]) + 1, i - 1, l[i]);
        for (auto j : Q[i]) if (j.first < i) {
            //err("%d -> %d\n", j.first, i);
            ans[j.second] = K.get(1, 0, n - 1, j.first, i - 1);
            //err("ans = %lld\n", ans[j.second]);
            int val = K.get(1, 0, n - 1, j.first, j.first);
            int pos = L.getL(1, 0, n - 1, j.first + 1, val);
            //err("pos = %d\n", pos);
            ans[j.second] += 1ll * (j.first - pos) * val;
            //err("ans = %lld\n", ans[j.second]);
        }
    }
    K.clear();
    for (int i = n - 1; i >= 0; --i) {
        K.upd(1, 0, n - 1, i + 1, K.getR(1, 0, n - 1, i, r[i]) - 1, r[i]);
        for (auto j : Q[i]) if (j.first > i) {
            ans[j.second] = K.get(1, 0, n - 1, i + 1, j.first);
            int val = K.get(1, 0, n - 1, j.first, j.first);
            int pos = R.getR(1, 0, n - 1, j.first - 1, val);
            ans[j.second] += 1ll * (pos - j.first) * val;
        }
    }
    for (int i = 0; i < q; ++i) {
        cout << ans[i] << "\n";
    }
}

int main() {
#ifdef SIR
    freopen("input.txt", "r", stdin); freopen("output.txt", "w", stdout);
#endif
    solve();
    return 0;
}