#include <bits/stdc++.h>

typedef long long ll;
using namespace std;

const ll p = (ll)1e+6 + 3ll;
const ll mod = (ll)1e+9 + 9ll;
const int MAXN = 2005;

ll p_pows[MAXN];
ll hs[MAXN], hss[MAXN], hsp[MAXN];

ll get_hash(const string &s)
{
    ll res = 0ll;
    for (int i = 0; i < (int)s.size(); i++)
        res = (res * p + (ll)s[i]) % mod;
    return res;
}

ll get_s(int l, int r)
{
    if (l > r)
        return 0ll;
    return ((hs[r] + mod - (hs[l - 1] * p_pows[r - l + 1] % mod)) % mod);
}

ll get_ss(int l, int r)
{
    if (l > r)
        return 0ll;
    return ((hss[r] + mod - (hss[l - 1] * p_pows[r - l + 1] % mod)) % mod);
}

ll get_sp(int l, int r)
{
    if (l > r)
        return 0ll;
    return ((hsp[r] + mod - (hsp[l - 1] * p_pows[r - l + 1] % mod)) % mod);
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);

    p_pows[0] = 1ll;
    for (int i = 1; i < MAXN; i++)
        p_pows[i] = (p_pows[i - 1] * p) % mod;

    string s;
    cin >> s;

    ll n = (ll)s.size(), k;
    cin >> k;

    for (int i = 1; i <= n; i++)
        hs[i] = (hs[i - 1] * p + (ll)s[i - 1]) % mod;

    string ss = s + s;
    for (int i = 1; i <= (int)ss.size(); i++)
        hss[i] = (hss[i - 1] * p + (ll)ss[i - 1]) % mod;

    string pref = "";
    ll prefsz = k % n;
    for (int i = 0; i < prefsz; i++)
        pref.push_back(s[i]);

    string sp = s + pref;
    //cout << sp << endl << endl;
    for (int i = 1; i <= (int)sp.size(); i++)
        hsp[i] = (hsp[i - 1] * p + (ll)sp[i - 1]) % mod;

    unordered_map<ll, ll> haves, havess, havesp;
    // CALC S SUBSTRINGS
    for (int i = 1; i <= (int)s.size(); i++)
    {
        for (int j = i; j <= (int)s.size(); j++)
        {
            haves[get_s(i, j)]++;
        }
    }

    // CALC SS SUBSTRINGS
    for (int i = 1; i <= n; i++)
    {
        for (int j = n + 1; j <= (int)ss.size(); j++)
        {
            havess[get_ss(i, j)]++;
        }
    }

    // CALC SP SUBSTRINGS
    for (int i = 1; i <= n; i++)
    {
        for (int j = n + 1; j <= (int)sp.size(); j++)
        {
            havesp[get_sp(i, j)]++;
        }
    }

    ll full_blocks = (k - n - k % n) / n;

    ll ans = (ll)haves.size() + (ll)havess.size() * full_blocks + (ll)havesp.size();
    cout << ans;

    //cout << endl << (ll)haves.size() << endl << (ll)havess.size() << endl << (ll)havesp.size() << endl << full_blocks << endl;

    /*cout << endl << "haves: " << haves.size() << endl;
    cout << endl << "havess: " << havess.size() << endl;
    cout << endl << "havesp: " << havesp.size() << endl;
    cout << endl << "fullblocks: " << full_blocks << endl;*/
    return 0;
}