#include <iostream>
#include <string>
#include <stack>
#include <utility>

using namespace std;

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    string input;
    cin >> input;
    auto result_size = static_cast<unsigned>(input.size() / 2);

    string result(result_size, ' ');

    stack<pair<char, int>> s;
    unsigned count_left = 0;
    unsigned count_right = 0;

    for (int i = 0; i < result_size; ++i) {
        int real_idx = i * 2;
        switch (input[real_idx]) {
            case '<': {
                ++count_left;

                if (!s.empty() && s.top().first == ')') {
                    result[s.top().second] = '[';
                    result[i] = ']';
                    s.pop();
                } else {
                    s.push(make_pair('(', i));
                }
                break;
            }
            case '>': {
                ++count_right;

                if (!s.empty() && s.top().first == '(') {
                    result[s.top().second] = '[';
                    result[i] = ']';
                    s.pop();
                } else {
                    s.push(make_pair(')', i));
                }
                break;
            }
            default: {
                break;
            }
        }
    }

    if (count_left != count_right) {
        cout << "Keine Loesung";
    } else {
        cout << result;
    }

    return 0;
}
