#include <iostream>
#include <algorithm>
#include <iomanip>
#include <string>
#include <vector>

using namespace std;
const int N = 50050, M = 200500;

#define mp make_pair
#define pii pair<int, int>
#define forn(i, n) for (int i = 0; i < n; i++)

vector<pii> g[N];
int dp[N];
bool used[N];
int edge_num[M];

int red[N], green[N], blue[N];

void dfs(int u) {
	if (used[u]) return;
	used[u] = true;
	for (auto v : g[u]) {
		dfs(v.first);
		int x = edge_num[v.second];
		if (x == 0) {
			red[u] = max(red[u], red[v.first] + 1);
		}
		else if (x == 1) {
			green[u] = max(green[u], green[v.first] + 1);
		}
		else {
			blue[u] = max(blue[u], blue[v.first] + 1);
		}
	}
}

signed main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);

	int n, m;
	cin >> n >> m;
	forn(i, m) {
		int u, v;
		cin >> u >> v;
		g[u].push_back(mp(v, i));
	}

	//clock_t t = clock();
	while (true) {
		forn(i, m) {
			edge_num[i] = rand() % 3;
		}
		fill_n(green, N, 0);
		fill_n(red, N, 0);
		fill_n(blue, N, 0);
		for (int i = 1; i <= n; i++) dfs(i);

		bool ok = true;
		for (int i = 1; i <= n; i++) {
			ok &= (blue[i] <= 42 && green[i] <= 42 && red[i] <= 42);
		}
		if (ok) {
			forn(i, m) {
				int x = edge_num[i];
				if (x == 0) {
					cout << 'R' << endl;
				}
				else if (x == 1) {
					cout << 'G' << endl;
				}
				else {
					cout << 'B' << endl;
				}
			}
			break;
		}
	}

	return 0;
}
