#include <iostream>
#include <algorithm>
#include <iomanip>
#include <string>
#include <vector>
#include <ctime>
#include <random>

using namespace std;
mt19937 gen(time(NULL));
const int N = 50050, M = 200500;

#define mp make_pair
#define pii pair<int, int>
#define forn(i, n) for (int i = 0; i < n; i++)

vector<pii> g[N];
bool used[N];
int edge_num[M];

int red[N], green[N], blue[N];

void dfs(int u) {
	if (used[u]) return;
	used[u] = true;
	for (auto v : g[u]) {
		dfs(v.first);
		int x = edge_num[v.second];
		bool won = false;

		// If okay, continue
		if (x == 0 && red[v.first] + 1 <= red[u])
			won = true;

		if (x == 1 && green[v.first] + 1 <= green[u])
			won = true;

		if (x == 2 && blue[v.first] + 1 <= blue[u])
			won = true;

		// If okay, recolor
		if (!won && red[v.first] + 1 <= red[u]) {
			won = true;
			x = 0;
			edge_num[v.second] = 0;
		}

		if (!won && green[v.first] + 1 <= green[u]) {
			won = true;
			x = 1;
			edge_num[v.second] = 1;
		}

		if (!won && blue[v.first] + 1 <= blue[u]) {
			won = true;
			x = 2;
			edge_num[v.second] = 2;
		}

		// Pick color with least length
		if (!won) {
			if (red[v.first] <= green[v.first] && red[v.first] <= blue[v.first]) {
				edge_num[v.second] = 0;
				red[u] = red[v.first] + 1;
			}
			else if (green[v.first] <= blue[v.first]) {
				edge_num[v.second] = 1;
				green[u] = green[v.first] + 1;
			}
			else {
				edge_num[v.second] = 2;
				blue[u] = blue[v.first] + 1;
			}
		}
	}
}

signed main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);

	int n, m;
	cin >> n >> m;
	forn(i, m) {
		int u, v;
		cin >> u >> v;
		g[u].push_back(mp(v, i));
	}

	forn(j, 5) for (int i = 1; i <= n; i++) random_shuffle(g[i].begin(), g[i].end());

	//clock_t t = clock();
	while (true) {
		forn(i, m) {
			edge_num[i] = gen() % 3;
		}
		fill_n(green, N, 0);
		fill_n(red, N, 0);
		fill_n(used, N, 0);
		fill_n(blue, N, 0);
		for (int i = 1; i <= n; i++) dfs(i);

		bool ok = true;
		for (int i = 1; i <= n; i++) {
			ok &= (blue[i] <= 42 && green[i] <= 42 && red[i] <= 42);
		}
		if (ok) {
			forn(i, m) {
				int x = edge_num[i];
				if (x == 0) {
					cout << 'R' << endl;
				}
				else if (x == 1) {
					cout << 'G' << endl;
				}
				else {
					cout << 'B' << endl;
				}
			}
			break;
		}
	}

	return 0;
}