#include <bits/stdc++.h>
using namespace std;

string to_string(string s) {
	return '"' + s + '"';
}

string to_string(const char *s) {
	return to_string((string) s);
}

template <typename A, typename B>
string to_string(pair<A, B> p) {
	return "(" + to_string(p.first) + ", " + to_string(p.second) + ")";
}

template <typename A>
string to_string(A v) {
	string res = "{";
	bool f = true;
	for (const auto &x : v) {
		if (!f) {
			res += ", ";
		}
		res += to_string(x);
		f = false;
	}
	res += "}";
	return res;
}

void debug_out() {
	cerr << endl;
}

template <typename First, typename... Rest>
void debug_out(First f, Rest... rest) {
	cerr << to_string(f) << " ";
	debug_out(rest...);
}

#ifdef LOCAL
#define debug(...) cerr << "[" << #__VA_ARGS__ << "]: ", debug_out(__VA_ARGS__)
#else
#define debug(...) 42
#endif

using ll = long long;
using pii = pair<int, int>;
using pll = pair<ll, ll>;

void solve() {
	ll t, p; cin >> t >> p;
	double lc = 0;
	double rc = 1e18;
	for (int i = 0; i < 128; i++) {
		double m = (lc + rc) / 2.0;
		double trest = 0.0;
		if (p > 20) {
			trest += (100 - p) * 1.0 / m;
		} else {
			trest += (100 - 20) * 1.0 / m;
			trest += (20 - p) * 1.0 / (m / 2);
		}
		if (trest > t) {
			lc = m;
		} else {
			rc = m;
		}
	}        
	double trest = 80.0 / (lc) + 20.0 / (lc/2.0);
	debug(lc, trest);
	cout << trest - t << endl;
}

signed main() {
#ifdef LOCAL
	freopen("xxx.in", "r", stdin);
	freopen("xxx.out", "w", stdout);
#endif
	cout.precision(12);
	cout.setf(ios::fixed | ios::showpoint);
	solve();
	return 0;
}
