#include <bits/stdc++.h>
using namespace std;

string to_string(string s) {
	return '"' + s + '"';
}

string to_string(const char *s) {
	return to_string((string) s);
}

template <typename A, typename B>
string to_string(pair<A, B> p) {
	return "(" + to_string(p.first) + ", " + to_string(p.second) + ")";
}

template <typename A>
string to_string(A v) {
	string res = "{";
	bool f = true;
	for (const auto &x : v) {
		if (!f) {
			res += ", ";
		}
		res += to_string(x);
		f = false;
	}
	res += "}";
	return res;
}

void debug_out() {
	cerr << endl;
}

template <typename First, typename... Rest>
void debug_out(First f, Rest... rest) {
	cerr << to_string(f) << " ";
	debug_out(rest...);
}

#ifdef LOCAL
#define debug(...) cerr << "[" << #__VA_ARGS__ << "]: ", debug_out(__VA_ARGS__)
#else
#define debug(...) 42
#endif

#define hash ahasdas

using ll = long long;
using pii = pair<int, int>;
using pll = pair<ll, ll>;

const ll N = 1000;
const ll B = 253;
const ll M = (ll) 1e9 + 7;
const ll M2 = 998244353ll;
string hs;

ll bp(ll x, ll n) {
	if (n == 0) return 1;
	if (n % 2 == 1) return (x * bp(x, n - 1)) % M;
	ll t = bp(x, n / 2);
	return (t * t) % M;
}

ll hash[N];
ll power[N];
ll rev[N];
ll ans[N];

ll getHash(int l, int r) {
	if (l == 0) {
		return hash[r];
	}

	int len = r - l + 1;
	ll res = (hash[r] - hash[l - 1] + M) % M;
	return (res * rev[l]) % M;
}

void solve() {
	string s; cin >> s;
	int n; cin >> n;

	if (s.size() == 1) {
		cout << n << endl;
		return;
	}

    hs = s + s;

	ll base = 1;
	for (int i = 0; i < hs.size(); i++) {
		power[i] = base;
		rev[i] = bp(base, M - 2);
		base = base * B;
		base %= M;
	}
    
	for (int i = 0; i < hs.size(); i++) {
		hash[i] = (hs[i] * power[i]) % M;
		if (i > 0) {
			hash[i] += hash[i - 1];
			hash[i] %= M;
		}
	}

	ll res = 0;
	for (int len = 1; len <= s.size(); len++) {
		set<ll> hset;
		for (int i = 0; i <= s.size() - len; i++) {
			hset.emplace(getHash(i, i + len - 1));
		}
		res += hset.size();
	}
	debug(res);

	string x = s;
	for (int i = 0; i < s.size(); i++) {
		x += s[i];
		int l = 0;
		int r = x.size();
		while (r - l > 1) {
			int m = (l + r) / 2;
			bool ok = false;
			for (int j = 0; j <= x.size() - m - 1; j++) {
//				debug(j, j + m - 1);
//				debug(x.size() - m, x.size() - 1);
				ll h1 = getHash(j, j + m - 1);
				ll h2 = getHash(x.size() - m, x.size() - 1);

//				debug(j, m, h1, h2);
				if (h1 == h2) {
					ok = true;
					break;
				}
			}
			if (ok) {
				l = m;
			} else {
				r = m;
			}
		}                   
		debug(i, l, x);
		ll k = s.size();
		ll cur = x.size() - l;
		debug(cur, (n - k) / k, (i < n % k ? 1 : 0));
		res += (cur * ((n - k) / k + (i < n % k ? 1 : 0)));
	}

	debug(res);
	cout << res << endl;
}

signed main() {
	ios::sync_with_stdio(false);
	cin.tie(0);
#ifdef LOCAL
	freopen("xxx.in", "r", stdin);
	freopen("xxx.out", "w", stdout);
#endif
	cout.precision(12);
	cout.setf(ios::fixed | ios::showpoint);
	solve();
	return 0;
}