#include <bits/stdc++.h>
using namespace std;

string to_string(string s) {
	return '"' + s + '"';
}

string to_string(const char *s) {
	return to_string((string) s);
}

template <typename A, typename B>
string to_string(pair<A, B> p) {
	return "(" + to_string(p.first) + ", " + to_string(p.second) + ")";
}

template <typename A>
string to_string(A v) {
	string res = "{";
	bool f = true;
	for (const auto &x : v) {
		if (!f) {
			res += ", ";
		}
		res += to_string(x);
		f = false;
	}
	res += "}";
	return res;
}

void debug_out() {
	cerr << endl;
}

template <typename First, typename... Rest>
void debug_out(First f, Rest... rest) {
	cerr << to_string(f) << " ";
	debug_out(rest...);
}

#ifdef LOCAL
#define debug(...) cerr << "[" << #__VA_ARGS__ << "]: ", debug_out(__VA_ARGS__)
#else
#define debug(...) 42
#endif

using ll = long long;
using pii = pair<int, int>;
using pll = pair<ll, ll>;

const int N = 255;
bool was[N][N];
bool dp[N][N];
string s;

bool f(int i, int j) {
	if (i > j) return true;

	if ((j - i + 1) % 2 != 0)
		return false;

	if (was[i][j]) {
		return dp[i][j];
	}

	was[i][j] = 1;

	bool ok = false;
	ok |= (s[i] != s[j]) && f(i + 1, j - 1);	
    
	int len = j - i + 1;
	for (int k = i + 1; k < j - 1; k++) {
		ok |= f(i, k) && f(k + 1, j);
	}

	return dp[i][j] = ok;
}

string ans(int i, int j) {
	if (i > j) return "";
                    
    if ((s[i] != s[j]) && f(i + 1, j - 1)) {
    	return '[' + ans(i + 1, j - 1) + ']';
    }
    
	int len = j - i + 1;
	for (int k = i + 1; k < j - 1; k++) {
		if (f(i, k) && f(k + 1, j)) {
			return ans(i, k) + ans(k + 1, j);
		}
	}

	assert(false);
	return "XYINA suka bleat :D";
}

void error() {
	cout << "Keine Loesung" << endl;
	exit(0);
}

void solve() {
	string tmp;	cin >> tmp;
	if (tmp.size() % 2 != 0) {            
		error();
	}

	for (int i = 0; i < tmp.size(); i += 2) {
		if (tmp[i] != tmp[i+1]) {
			error();
		}

		if (tmp[i] == '<') s += 'L';
		else s += 'R';
	}

	int n = s.size();
	if (!f(0, n - 1)) {
		error();
	}

	cout << ans(0, n - 1) << endl;
}

signed main() {
#ifdef LOCAL
	freopen("xxx.in", "r", stdin);
	freopen("xxx.out", "w", stdout);
#endif
	cout.precision(12);
	cout.setf(ios::fixed | ios::showpoint);
	solve();
	return 0;
}