#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef long double ld;
typedef pair<ll, ll> par;

#define X first
#define Y second
#define pw(x) (1ll << (x))
#define all(x) (x).begin(), (x).end()

const ll MOD1 = ll(1e9) + 17;
const ll MOD2 = ll(1e9) + 19;
const ll P = 239;

set<par> hs;

par p[4000];

vector<par> getHS(string &s) {
    vector<par> hs(s.size() + 1);
    hs[0] = {0, 0};
    for (int i = 0; i < s.size(); ++i) {
        hs[i + 1].X = (hs[i].X * P + s[i]) % MOD1;
        hs[i + 1].Y = (hs[i].Y * P + s[i]) % MOD2;
    }
    return hs;
}

par substrH(vector<par> &hs, ll l, ll r) { // [)

    ll res1 = hs[r].X;
    ll h11 = (hs[l].X * p[r - l].X) % MOD1;
    res1 -= h11;
    if (res1 < 0) res1 += MOD1;

    ll res2 = hs[r].Y;
    ll h12 = (hs[l].Y * p[r - l].Y) % MOD2;
    res2 -= h12;
    if (res2 < 0) res2 += MOD2;

    return {res1, res2};
}

void srt(int v, vector< vector<pair<int, int>>> &g, vector<bool>&used, vector<int>& sorted) {
    used[v] = true;
    for (auto p : g[v]) {
        int u = p.first;
        if (used[u]) continue;
        srt(u, g, used, sorted);
    }
    sorted.push_back(v);
}

bool try_rnd(vector< vector< pair<int, int> > > &g, vector<int> &sorted, vector< vector<int> > &cnt_in, vector<int>& res) {
    int n = sorted.size();
    for (int v = 0; v < n; ++v) {
        vector<int> colors;
        for (int i = 0; i < 3; ++i) {
            if (cnt_in[v][i] < 42) colors.push_back(i);
        }
        if (colors.empty()) return false;
        for (auto p : g[v]) {
            int cur_col = colors[rand() % colors.size()];
            res[p.second] = cur_col;
            cnt_in[p.first][cur_col] = max(cnt_in[p.first][cur_col], cnt_in[v][cur_col] + 1);
        }
    }
    return true;
}

void source() {
    int n, m;
    cin >> n >> m;
    vector< vector<pair<int, int>>> g(n);
    for (int i = 0; i < m; ++i) {
        int a, b;
        cin >> a >> b;
        --a, --b;
        g[a].push_back({b, i});
    }

    vector<bool> usd1(n, false);
    vector<int> sorted;
    for (int i = 0; i < n; ++i) {
        if (usd1[i]) continue;
        srt(i, g, usd1, sorted);
    }
    reverse(sorted.begin(), sorted.end());
    vector< vector<int> > cnt_in(n, vector<int>(3, 0));
    char LETTERS[3] = {'R', 'G', 'B'};

    while (true) {
        vector<int> res(m, -1);
        bool success = try_rnd(g, sorted, cnt_in, res);
        if (!success) continue;
        for (int x : res) {
            cout << LETTERS[x] << "\n";
        }
        break;
    }

}

int main() {
#ifdef BOSOV
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    ios::sync_with_stdio(false);
    cin.tie(0);

    source();

#ifdef BOSOV
    cerr << "TIME :: " << clock() * 1.0 / CLOCKS_PER_SEC << endl;
#endif
    return 0;
}